import numpy as np
from itertools import product

# Inverse S-box (used to reverse SubBytes)
inverse_sbox = [
    0x52, 0x09, 0x6a, 0xd5, 0x30, 0x36, 0xa5, 0x38, 0xbf, 0x40, 0xa3, 0x9e, 0x81, 0xf3, 0xd7, 0xfb,
    0x7c, 0xe3, 0x39, 0x82, 0x9b, 0x2f, 0xff, 0x87, 0x34, 0x8e, 0x43, 0x44, 0xc4, 0xde, 0xe9, 0xcb,
    0x54, 0x7b, 0x94, 0x32, 0xa6, 0xc2, 0x23, 0x3d, 0xee, 0x4c, 0x95, 0x0b, 0x42, 0xfa, 0xc3, 0x4e,
    0x08, 0x2e, 0xa1, 0x66, 0x28, 0xd9, 0x24, 0xb2, 0x76, 0x5b, 0xa2, 0x49, 0x6d, 0x8b, 0xd1, 0x25,
    0x72, 0xf8, 0xf6, 0x64, 0x86, 0x68, 0x98, 0x16, 0xd4, 0xa4, 0x5c, 0xcc, 0x5d, 0x65, 0xb6, 0x92,
    0x6c, 0x70, 0x48, 0x50, 0xfd, 0xed, 0xb9, 0xda, 0x5e, 0x15, 0x46, 0x57, 0xa7, 0x8d, 0x9d, 0x84,
    0x90, 0xd8, 0xab, 0x00, 0x8c, 0xbc, 0xd3, 0x0a, 0xf7, 0xe4, 0x58, 0x05, 0xb8, 0xb3, 0x45, 0x06,
    0xd0, 0x2c, 0x1e, 0x8f, 0xca, 0x3f, 0x0f, 0x02, 0xc1, 0xaf, 0xbd, 0x03, 0x01, 0x13, 0x8a, 0x6b,
    0x3a, 0x91, 0x11, 0x41, 0x4f, 0x67, 0xdc, 0xea, 0x97, 0xf2, 0xcf, 0xce, 0xf0, 0xb4, 0xe6, 0x73,
    0x96, 0xac, 0x74, 0x22, 0xe7, 0xad, 0x35, 0x85, 0xe2, 0xf9, 0x37, 0xe8, 0x1c, 0x75, 0xdf, 0x6e,
    0x47, 0xf1, 0x1a, 0x71, 0x1d, 0x29, 0xc5, 0x89, 0x6f, 0xb7, 0x62, 0x0e, 0xaa, 0x18, 0xbe, 0x1b,
    0xfc, 0x56, 0x3e, 0x4b, 0xc6, 0xd2, 0x79, 0x20, 0x9a, 0xdb, 0xc0, 0xfe, 0x78, 0xcd, 0x5a, 0xf4,
    0x1f, 0xdd, 0xa8, 0x33, 0x88, 0x07, 0xc7, 0x31, 0xb1, 0x12, 0x10, 0x59, 0x27, 0x80, 0xec, 0x5f,
    0x60, 0x51, 0x7f, 0xa9, 0x19, 0xb5, 0x4a, 0x0d, 0x2d, 0xe5, 0x7a, 0x9f, 0x93, 0xc9, 0x9c, 0xef,
    0xa0, 0xe0, 0x3b, 0x4d, 0xae, 0x2a, 0xf5, 0xb0, 0xc8, 0xeb, 0xbb, 0x3c, 0x83, 0x53, 0x99, 0x61,
    0x17, 0x2b, 0x04, 0x7e, 0xba, 0x77, 0xd6, 0x26, 0xe1, 0x69, 0x14, 0x63, 0x55, 0x21, 0x0c, 0x7d
]

sbox = [
    0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b, 0xfe, 0xd7, 0xab, 0x76,
    0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0, 0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0,
    0xb7, 0xfd, 0x93, 0x26, 0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15,
    0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2, 0xeb, 0x27, 0xb2, 0x75,
    0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0, 0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84,
    0x53, 0xd1, 0x00, 0xed, 0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf,
    0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f, 0x50, 0x3c, 0x9f, 0xa8,
    0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5, 0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2,
    0xcd, 0x0c, 0x13, 0xec, 0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73,
    0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14, 0xde, 0x5e, 0x0b, 0xdb,
    0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c, 0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79,
    0xe7, 0xc8, 0x37, 0x6d, 0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08,
    0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f, 0x4b, 0xbd, 0x8b, 0x8a,
    0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e, 0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e,
    0xe1, 0xf8, 0x98, 0x11, 0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf,
    0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f, 0xb0, 0x54, 0xbb, 0x16
]
def reverse_key_expansion(subkey_round_10):
    # The number of rounds in AES (10 rounds for AES-128)
    num_rounds = 10

    # The key size in words (4 words for AES-128)
    key_size = len(subkey_round_10)

    # Initialize an array to store the expanded key
    expanded_key = np.zeros((4, key_size * (num_rounds + 1)), dtype=np.uint8)

    # Copy the subkey of round 10 to the last column of the expanded key
    expanded_key[:, -key_size:] = subkey_round_10.reshape((4, key_size))

    # Iterate backward through the rounds to reverse the key expansion
    for round_num in range(num_rounds, 0, -1):
        # Perform the key schedule core operation
        temp = np.copy(expanded_key[:, (round_num - 1) * key_size:round_num * key_size])
        temp = np.roll(temp, -1, axis=0)  # Shift rows
        temp = np.apply_along_axis(substitute_byte, 0, temp)  # Substitute bytes
        rcon = get_round_constant(round_num)
        temp[:, 0] ^= rcon  # XOR with the round constant
        temp[:, 1:] ^= expanded_key[:, (round_num - 2) * key_size:(round_num - 1) * key_size]
        expanded_key[:, (round_num - 1) * key_size:round_num * key_size] = temp

    # Extract the original master key from the first columns of the expanded key
    master_key = expanded_key[:, :key_size].reshape((-1,))

    return master_key

def substitute_byte(byte):
    # AES S-box substitution
    return sbox[byte]

def get_round_constant(round_num):
    # AES round constant calculation
    return np.array([rcon(round_num), 0, 0, 0], dtype=np.uint8)

def rcon(round_num):
    # AES round constant values
    if round_num == 1:
        return 0x01
    elif round_num > 1 and rcon(round_num - 1) < 0x80:
        return (2 * rcon(round_num - 1)) % 0x100
    elif round_num > 1:
        return (2 * rcon(round_num - 1)) ^ 0x1b

def reverse_sub_bytes(state_matrix):
    assert len(state_matrix) == 4

    for i in range(4):
        state_matrix[i] = inverse_sbox[state_matrix[i]]

    return state_matrix

def mix_columns(column):
    # Ensure the column is a list of 4 bytes
    assert len(column) == 4

    # Define the Galois multiplication matrix
    matrix = [
        [0x02, 0x03, 0x01, 0x01],
        [0x01, 0x02, 0x03, 0x01],
        [0x01, 0x01, 0x02, 0x03],
        [0x03, 0x01, 0x01, 0x02]
    ]

    # Perform matrix multiplication in GF(2^8)
    result = [
        (matrix[i][0] * column[0] +
         matrix[i][1] * column[1] +
         matrix[i][2] * column[2] +
         matrix[i][3] * column[3]) % 0x100
        for i in range(4)
    ]

    return result

def reverse_shift_rows(state):
    # Ensure the state is a 16-byte array
    assert len(state) == 16

    # Reverse the shift on the second row
    state[1], state[5], state[9], state[13] = \
        state[13], state[1], state[5], state[9]

    # Reverse the shift on the third row
    state[2], state[6], state[10], state[14] = \
        state[10], state[14], state[2], state[6]

    # Reverse the shift on the fourth row
    state[3], state[7], state[11], state[15] = \
        state[7], state[11], state[15], state[3]

    return state

def reverse_add_round_key_column(column, round_key):
    assert len(column) == 4
    assert len(round_key) == 4
    return np.bitwise_xor(column,round_key)


# Specify the file path
file_ciphertexts = '../aes_encrypt/ciphertexts.npy'
file_faulty_ciphertexts = '../aes_encrypt/faulty_ciphertexts.npy'

# Load data from the .npy file
np_ciphertexts  = np.load(file_ciphertexts)
np_faulty_ciphertexts = np.load(file_faulty_ciphertexts)

# DELTA = ensemble des erreus possibles
DELTA = []
L0 = []
L1 = []
L2 = []
L3 = []
for i in range(4):
    for e in range(256):
        error = np.zeros(4)
        error[i] = e
        DELTA.append(mix_columns(error))
        L0.append(error[0])
        L1.append(error[1])
        L2.append(error[2])
        L3.append(error[3])

ncolumn = 0
#Possibles keys
R = []
for kcolumn in product(range(256), repeat=4):
    print(kcolumn)
    bool = True
    for n in range(np_ciphertexts.shape[1]):
        a = reverse_shift_rows(np_ciphertexts[n])[4*ncolumn:4*(ncolumn+1)]
        b = reverse_add_round_key_column(a,kcolumn)
        c = reverse_sub_bytes(b)

        a_ = reverse_shift_rows(np_faulty_ciphertexts[n])[0:4]
        b_ = reverse_add_round_key_column(a_,kcolumn)
        c_ = reverse_sub_bytes(b_)

        mc_error = np.bitwise_xor(c,c_)

        if (mc_error[0] not in L0 \
            or mc_error[1] not in L1 \
            or mc_error[2] not in L2 \
            or mc_error[3] not in L3):
            bool = False
            break

        is_in_array = any(np.array_equal(mc_error, arr) for arr in DELTA)
        if (not is_in_array):
            bool = False
            break
    
    if (not bool):
        continue
    else:
        print(f"Found {kcolumn}")
        R.append(kcolumn)
    

print(R)
